# coding: utf-8

"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectSectionInsertRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'section': 'str',
        'before_section': 'str',
        'after_section': 'str'
    }

    attribute_map = {
        'section': 'section',
        'before_section': 'before_section',
        'after_section': 'after_section'
    }

    def __init__(self, section=None, before_section=None, after_section=None):  # noqa: E501
        """ProjectSectionInsertRequest - a model defined in Swagger"""  # noqa: E501
        self._section = None
        self._before_section = None
        self._after_section = None
        self.discriminator = None
        self.section = section
        if before_section is not None:
            self.before_section = before_section
        if after_section is not None:
            self.after_section = after_section

    @property
    def section(self):
        """Gets the section of this ProjectSectionInsertRequest.  # noqa: E501

        The section to reorder.  # noqa: E501

        :return: The section of this ProjectSectionInsertRequest.  # noqa: E501
        :rtype: str
        """
        return self._section

    @section.setter
    def section(self, section):
        """Sets the section of this ProjectSectionInsertRequest.

        The section to reorder.  # noqa: E501

        :param section: The section of this ProjectSectionInsertRequest.  # noqa: E501
        :type: str
        """
        if section is None:
            raise ValueError("Invalid value for `section`, must not be `None`")  # noqa: E501

        self._section = section

    @property
    def before_section(self):
        """Gets the before_section of this ProjectSectionInsertRequest.  # noqa: E501

        Insert the given section immediately before the section specified by this parameter.  # noqa: E501

        :return: The before_section of this ProjectSectionInsertRequest.  # noqa: E501
        :rtype: str
        """
        return self._before_section

    @before_section.setter
    def before_section(self, before_section):
        """Sets the before_section of this ProjectSectionInsertRequest.

        Insert the given section immediately before the section specified by this parameter.  # noqa: E501

        :param before_section: The before_section of this ProjectSectionInsertRequest.  # noqa: E501
        :type: str
        """

        self._before_section = before_section

    @property
    def after_section(self):
        """Gets the after_section of this ProjectSectionInsertRequest.  # noqa: E501

        Insert the given section immediately after the section specified by this parameter.  # noqa: E501

        :return: The after_section of this ProjectSectionInsertRequest.  # noqa: E501
        :rtype: str
        """
        return self._after_section

    @after_section.setter
    def after_section(self, after_section):
        """Sets the after_section of this ProjectSectionInsertRequest.

        Insert the given section immediately after the section specified by this parameter.  # noqa: E501

        :param after_section: The after_section of this ProjectSectionInsertRequest.  # noqa: E501
        :type: str
        """

        self._after_section = after_section

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectSectionInsertRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectSectionInsertRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
